package com.eactive.eai.common.util.convert;

import java.util.Stack;

import org.nfunk.jep.ParseException;
import org.nfunk.jep.function.PostfixMathCommand;


/**
 * ASCII 값을 EBCDIC으로 변환하는 함수.
 * 입력 값은 byte[], 결과는 byte[]임.
 */
public class ASCII2EBCDIC extends PostfixMathCommand {
    public ASCII2EBCDIC() {
        numberOfParameters = 1;
    }

    @SuppressWarnings({ "rawtypes", "unchecked" })
	public void run(Stack inStack) throws ParseException {
        checkStack(inStack);

        Object param = inStack.pop();

        byte[] value = null;

        if (param instanceof String) {
            value = ((String) param).getBytes();
        } else if (param instanceof byte[]) {
            value = (byte[]) param;
        } else if (param == null) {
            inStack.push(null);
        } else {
            throw new ParseException(
                "Function의 파라미터 인수가 byte[], String이 아닙니다. : " + param);
        }
        if (value == null) {// 20250910 npe 추가
            throw new ParseException("value is null");
        }
        try {
            inStack.push(IConv.asciiToEBCDIC(new String(value)));
        } catch (Exception e) {
            throw new ParseException(e.getMessage());
        }
    }
}
